/* $Id: compliance.js,v 1.34 2009/10/09 11:19:29 roopa Exp $ */

function loadDDPolicyData(policySelectVal,resourceId)
{
    if(policySelectVal == "All Policies")
    {
       policySelectVal = "ALL";
    }
    
    stateData["NCMDDCompTableView"]["_D_RP"]= "&COMPPOLICY_ID=" + policySelectVal + "&RESOURCEID=" + resourceId;
    refreshSubView('NCMDDCompTableView');
}


function showCriteriaType(criteriaType)
{
  var simpleRow = document.getElementById('simple_criteria_row');
  var advRow = document.getElementById('adv_criteria_row');
  var advBlockRow = document.getElementById('adv_block_criteria_row');
  var advBlockHeaderRow = document.getElementById('advanced_block_criteria_header');
  var advHeaderRow = document.getElementById('advanced_criteria_header');
  if(criteriaType == 'simple')
  {
    simpleRow.className = '';
    advRow.className = 'hide';
    advBlockRow.className = 'hide';
    advHeaderRow.className = 'hide';
    advBlockHeaderRow.className = 'hide';    
  }
  else if(criteriaType == 'advanced')
  {
    simpleRow.className = 'hide';
    advBlockHeaderRow.className = 'hide';
    advBlockRow.className = 'hide';
    advRow.className = '';    
    advHeaderRow.className = '';
  }
  else // for advanced block criteria
  {
    advBlockHeaderRow.className = '';
    advBlockRow.className = '';
    advRow.className = '';
    simpleRow.className = 'hide';    
    advHeaderRow.className = 'hide';
  }
}

function addAdvCriteriaToForm(addruleform,valcriteriaform)
{
   var rowCountEle = addruleform.ROWIDX;
   if(rowCountEle.length != undefined)
   {
     var noOfRows = rowCountEle.length;
     for(var i=0;i<noOfRows;i++)
     {
	var comparator = document.getElementById("COMPARATOR_" + rowCountEle[i].value).value;
	var condition = document.getElementById("CONDITION_" + rowCountEle[i].value).value;
	var pattern = document.getElementById("PATTERN_" + rowCountEle[i].value).value;
        addCriteriaToForm(comparator,condition,pattern,i+1,valcriteriaform);
     }

     var newCompEle = document.createElement("input");
     newCompEle.setAttribute("type","hidden");
     newCompEle.setAttribute("name","ROWCOUNT");
     newCompEle.setAttribute("value",noOfRows);
     valcriteriaform.appendChild(newCompEle);
   }
   else
   {
     var comparator = document.getElementById("COMPARATOR_1").value;
     var condition = document.getElementById("CONDITION_1").value;
     var pattern = document.getElementById("PATTERN_1").value;
     addCriteriaToForm(comparator,condition,pattern,'1',valcriteriaform);
     
     var newCompEle = document.createElement("input");
     newCompEle.setAttribute("type","hidden");
     newCompEle.setAttribute("name","ROWCOUNT");
     newCompEle.setAttribute("value",'1');
     valcriteriaform.appendChild(newCompEle);
   }
   
   var criteriatype = 'Advanced';
   if(addruleform.CRITERIA_TYPE[2].checked)
   {
	var newStartBlockConfigEle = document.createElement("input");
	newStartBlockConfigEle.setAttribute("type","hidden");
    	newStartBlockConfigEle.setAttribute("name","STARTBLOCKCONFIG");
    	newStartBlockConfigEle.setAttribute("value",document.CompAddRuleForm.START_BLOCK_CONFIG.value);
    	valcriteriaform.appendChild(newStartBlockConfigEle);

    	var newEndBlockConfigEle = document.createElement("input");
    	newEndBlockConfigEle.setAttribute("type","hidden");
    	newEndBlockConfigEle.setAttribute("name","ENDBLOCKCONFIG");
    	newEndBlockConfigEle.setAttribute("value",document.CompAddRuleForm.END_BLOCK_CONFIG.value);            
    	valcriteriaform.appendChild(newEndBlockConfigEle);            	   
  
	var newBlockConditionEle = document.createElement("input");	 
	newBlockConditionEle.setAttribute("type","hidden");	 
	newBlockConditionEle.setAttribute("name","BLOCK_CONDITION");	 
	newBlockConditionEle.setAttribute("value",document.CompAddRuleForm.BLOCK_CONDITION.value);	 
	valcriteriaform.appendChild(newBlockConditionEle);	 

	var newBlockConditionValueEle = document.createElement("input");	 
	newBlockConditionValueEle.setAttribute("type","hidden");	 
	newBlockConditionValueEle.setAttribute("name","BLOCK_CONDITION_VALUE");	 
	newBlockConditionValueEle.setAttribute("value",document.CompAddRuleForm.BLOCK_CONDITION_VALUE.value);	 
	valcriteriaform.appendChild(newBlockConditionValueEle);

   	criteriatype = 'AdvancedBlockCriteria';
   }   
    var newCriTypeEle = document.createElement("input");
    newCriTypeEle.setAttribute("type","hidden");
    newCriTypeEle.setAttribute("name","VALIDATECRITERIA");
    newCriTypeEle.setAttribute("value","true");
    valcriteriaform.appendChild(newCriTypeEle);

    var newCriTypeEle = document.createElement("input");
    newCriTypeEle.setAttribute("type","hidden");
    newCriTypeEle.setAttribute("name","CRITERIATYPE");
    newCriTypeEle.setAttribute("value",criteriatype);
    valcriteriaform.appendChild(newCriTypeEle);
}

function addCriteriaToForm(comparator,condition,pattern,count,form)
{
   var newCompEle = document.createElement("input");
   newCompEle.setAttribute("type","hidden");
   newCompEle.setAttribute("name","COMPARATOR_" + count);
   newCompEle.setAttribute("value",comparator);
   form.appendChild(newCompEle);

   var newConEle = document.createElement("input");
   newConEle.setAttribute("type","hidden");
   newConEle.setAttribute("name","CONDITION_" + count);
   newConEle.setAttribute("value",condition);
   form.appendChild(newConEle);

   var newPattEle = document.createElement("input");
   newPattEle.setAttribute("type","hidden");
   newPattEle.setAttribute("name","PATTERN_" + count);
   newPattEle.setAttribute("value",pattern);
   form.appendChild(newPattEle);
}


function getRulesForRuleGrp()
{
   var rgId = document.getElementById('RULEGROUP').value;
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/compliance/Import.jsp?COMPRULEGROUP_ID=" + rgId;
   
   xmlhttp.onreadystatechange = function(){
	if(xmlhttp.readyState == 4)
	{
	  if(xmlhttp.status == 200)
	  {
	     var result = xmlhttp.responseText;
	     //alert(result);
	     //result = trimAll(result);
	     //document.getElementById('loading_row').className='hide';

	     /*var lineArray = result.split('\n');
	     var len = lineArray.length;
	     var bodyText = "";
	     for(var j=0;j<len;j++)
	     {
	       bodyText = bodyText + lineArray[j] + "<br>";
	     }*/
	  
	     closeDialog();	
	  }	
	}
      };
      
   xmlhttp.open("GET",url,true);      
   xmlhttp.send(null);   
}


function getRuleGrpsForPolicy()
{
   var policyId = document.getElementById('POLICYNAME').value;
   var xmlhttp = AjaxAPI.getXMLHttpRequest();
   var url = "jsp/compliance/Import.jsp?COMPPOLICY_ID=" + policyId;
   
   xmlhttp.onreadystatechange = function(){
	if(xmlhttp.readyState == 4)
	{
	  if(xmlhttp.status == 200)
	  {
	     var result = xmlhttp.responseText;
	     //alert(result);
	     //result = trimAll(result);
	     //document.getElementById('loading_row').className='hide';

	     /*var lineArray = result.split('\n');
	     var len = lineArray.length;
	     var bodyText = "";
	     for(var j=0;j<len;j++)
	     {
	       bodyText = bodyText + lineArray[j] + "<br>";
	     }*/
	  
	     closeDialog();	
	  }	
	}
      };
      
   xmlhttp.open("GET",url,true);      
   xmlhttp.send(null);   
}


function getSelectedRulesForAddRG(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select a Rule"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("COMPRULE_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "COMPRULE_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
 
   form.action = getURLSuffixed(form.action) + "?" + pkValueStr;
   return true;
      
}


function getSelectedRGsForAddPolicy(form,viewName)
{
   var tblModel = getTableModel(viewName);
   if(!tblModel.isAtleastOneChecked("Select a Rule Group"))
   {
   	return false;
   }
   
   var selIndices = tblModel.getSelectedRowIndices();
   var colInd = tblModel.getColumnIndex("COMPRULEGROUP_ID");
   
   var pkValueStr = "";
   for(var i=0;i<selIndices.length;i++)
   {
      pkValueStr = pkValueStr + "&" + "COMPRULEGROUP_ID" + "=" + tblModel.getValueAt(selIndices[i],colInd);
   }
   
   form.action = getURLSuffixed(form.action) + pkValueStr;
   return true;
      
}

function validateCompRuleCriteria(form)
{
  // validate simple criteria
  if(form.CRITERIA_TYPE[0].checked)
  {
    if(!isNotEmpty(form.SIMPLE_PATTERN.value))
    {
      alert(I18N.getMsg("js.compliance.validateCompRuleCriteria.alert.1"));
      return false;
    }
    
     var iChars = "!\"#$\'*+?";
        for (var i = 0; i < form.SIMPLE_PATTERN.value.length; i++) 
        {
  	        if (iChars.indexOf(form.SIMPLE_PATTERN.value.charAt(i)) != -1) 
  	        {
			if(form.SIMPLE_PATTERN.value.charAt(i-1)=="\\")
			{
			    continue;
			}
			else
			{
			    alert(I18N.getMsg("js.compliance.validateCompRuleCriteria.alert.2")+" \n\n"
			    + "                                           ! \" # $ \' * + ? \n\n "
			    + I18N.getMsg("js.compliance.validateCompRuleCriteria.alert.3") +" \\$ \)");


			    form.SIMPLE_PATTERN.focus();
			    return false;
			}
            	}
        }    
  }
  // validate advanced criteria & advanced block criteria
  else
  {
    return validateAdvCriteria(form);
  }
  
  return true;
  
}

function validateAdvCriteria(form)
{
   var rowCountEle = form.ROWIDX;
   if(rowCountEle.length != undefined)
   {
     var noOfRows = rowCountEle.length;
     for(var i=0;i<noOfRows;i++)
     {
        var patternobj = document.getElementById("PATTERN_" + rowCountEle[i].value);
	var pattern = patternobj.value;
        if(!isNotEmpty(pattern))
        {
          alert(I18N.getMsg("js.compliance.validateCompRuleCriteria.alert.1"));
          return false;
        }
        else
        {
           if(!checkForMetaChar(patternobj))
           {
           	return false;
           }
        }
     }
   }
   else
   {
       var patternobj = document.getElementById("PATTERN_1");
       var pattern = patternobj.value;
       if(!isNotEmpty(pattern))
       {
     	   alert(I18N.getMsg("js.compliance.validateCompRuleCriteria.alert.1"));
     	   return false;
       }
       else
       {
           if(!checkForMetaChar(patternobj))
           {
           	return false;
           }
       }
   }

   // For Block Criteria
   if(form.CRITERIA_TYPE[2].checked)
   {
    if(!isNotEmpty(form.START_BLOCK_CONFIG.value))
    {
      alert(I18N.getMsg("js.compliance.validateAdvCriteria.alert"));
      form.START_BLOCK_CONFIG.focus();
      return false;
    }
    if(!isNotEmpty(form.END_BLOCK_CONFIG.value))
    {
      alert(I18N.getMsg("js.compliance.validateAdvCriteria.alert"));
      form.END_BLOCK_CONFIG.focus();
      return false;
    }
    if(form.BLOCK_CONDITION.value != "NONE")	 
     {	 
         if(!isNotEmpty(form.BLOCK_CONDITION_VALUE.value))	 
         {	 
            alert(I18N.getMsg("js.compliance.validateAdvCriteria.Enter"));	 
            form.BLOCK_CONDITION_VALUE.focus();	 
            return false;	 
         }	 
     }
   }

   return true;
   
}


function checkForMetaChar(patternobj)
{
    var metachar = "*+?";
    for(var i=0;i<metachar.length;i++) 
    {    
	if(trim(patternobj.value).indexOf(metachar.charAt(i)) == 0) 
	{
	    alert(I18N.getMsg("js.compliance.checkForMetaChar.alert.1")+metachar.charAt(i)+I18N.getMsg("js.compliance.checkForMetaChar.alert.2"));	    
	    patternobj.focus();
	    return false;
	}
    }     
    return true;
}


function validateAdhocTestDeviceLimit(form,testType)
{
  if(form.ComponentSelection[0].checked)
  {
        if(testType == 'POLICY' && form.SELECTEDDEVICES.length > 20)
        {
	   alert(I18N.getMsg("js.compliance.validateAdhocTestDeviceLimit.alert.1"));
	   return false;
        }
	else if(form.SELECTEDDEVICES.length > 50)
	{
	   alert(I18N.getMsg("js.compliance.validateAdhocTestDeviceLimit.alert.2"));
	   return false;
	}
  }
  else
  {
  	var selectedIndex = form.DEVICEGROUPSELECTION.selectedIndex;
  	var dgId = form.DEVICEGROUPSELECTION.options[selectedIndex].value;
  	
        var xmlhttp = AjaxAPI.getXMLHttpRequest();
        var url = "jsp/compliance/GetDGDeviceCount.jsp?DEVICE_GROUP_ID=" + dgId;
        xmlhttp.open("GET",url,false);      
        xmlhttp.send(null);
        deviceCount = new Number(trimAll(xmlhttp.responseText));
        if(testType == 'POLICY' && deviceCount > 20)
        {
          alert(I18N.getMsg("js.compliance.validateAdhocTestDeviceLimit.alert.3"));	     
	  return false;	     
        }
        else if(deviceCount > 50)
        {
          alert(I18N.getMsg("js.compliance.validateAdhocTestDeviceLimit.alert.4"));	     
	  return false;	     
        }
        else if(deviceCount == 0)
        {
          alert(I18N.getMsg("js.compliance.validateAdhocTestDeviceLimit.alert.5"));	     
	  return false;	     
        }
  }
  
  return true;
  
}


function showRulesInRuleGroup(menuItemId, srcViewRefId, additionalParams,index)
{
    var tablemodel = getTableModel(srcViewRefId);
    var rgName = tablemodel.getValueAt(index,tablemodel.getColumnIndex("COMPRULEGROUP_NAME"));
    var title = I18N.getMsg("js.compliance.showRulesInRuleGroup.title") + rgName;
    
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title=" + title + ",modal=no,width=700,closePrevious=false");
}

function showAddCompRule(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title="+I18N.getMsg("js.compliance.showAddCompRule.title")+",modal=no,width=750");
}

function showAddCompRuleGrp(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    removeStateForView('NCMAddRGRuleList');
    var url = updateStateCookieAndAppendSid(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    showURLInDialog(url,"position=absmiddle,title="+I18N.getMsg("js.compliance.showAddCompRuleGrp.title")+",modal=no,width=750");
}

function showAddCompPolicy(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    removeStateForView('NCMAddPolicyRGList');
    var url = updateStateCookieAndAppendSid(menuItemObj.getActionURL(srcViewRefId,additionalParams,index));
    showURLInDialog(url,"position=absmiddle,title="+I18N.getMsg("js.compliance.showAddCompPolicy.title")+",modal=no,width=750");
}

function showAssociateDevices(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"position=absmiddle,title="+I18N.getMsg("js.compliance.showAssociateDevices.title")+",modal=no,width=750");
}

function showVersionDraftCompCheckInput(menuItemId, srcViewRefId, additionalParams,index)
{
    var menuItemObj = getMenuItemObj(menuItemId);
    showURLInDialog(menuItemObj.getActionURL(srcViewRefId,additionalParams,index),"title="+I18N.getMsg("js.compliance.showVersionDraftCompCheckInput.title")+",closePrevious=false",null,srcViewRefId);
}


function changePolicySelectionType(selectionType)
{
  var assignedHeader = document.getElementById('assigned_header');
  var assignedList = document.getElementById('assigned_list');

  var selectionHeader = document.getElementById('selection_header');
  var selectionList = document.getElementById('selection_list');
  
  if(selectionType == 'ASSIGNED')
  {
    assignedHeader.className = '';
    assignedList.className = '';
    selectionHeader.className = 'hide';
    selectionList.className = 'hide';
  }
  else
  {
    assignedHeader.className = 'hide';
    assignedList.className = 'hide';
    selectionHeader.className = '';
    selectionList.className = '';
  }
}

function setComplianceShowResult(value)
{
    var respolicyobj = document.getElementById("RESOURCE_POLICY_ID");
    if(respolicyobj != undefined)
    {
	var url = "NCMDevicePolicyDetailsView.cc?SHOW_RESULT_CONTENT="+value+"&RESOURCE_POLICY_ID="+respolicyobj.value;
	AjaxAPI.sendRequest({EFFECT:"Effect.Appear",METHOD:"POST",URL:url,TARGET:"_view_NCMDevicePolicyDetailsView"});
    }
}

function handleComplianceShowResult(menuItemId,srcViewRefId,additionalParams,index)
{
    if(document.getElementById("COMPLIANCE_SHOW_RESULT")!=null)
    {
        if(additionalParams!=null && additionalParams!="undefined" )
        additionalParams+="&SHOW_RESULT_CONTENT="+document.getElementById("COMPLIANCE_SHOW_RESULT").value;
        else
        additionalParams="&SHOW_RESULT_CONTENT="+document.getElementById("COMPLIANCE_SHOW_RESULT").value;

    }
    TableDOMModel.showDetailsAction(menuItemId,srcViewRefId,additionalParams,index);
}

function enableAdvancedBlockCriteriaValue(selectobj)
{
	var selected = selectobj.options[selectobj.selectedIndex].value;
	var valueobj = document.getElementById("BLOCK_CONDITION_VALUE");
	var oldvalueobj = document.getElementById("OLD_BLOCK_CONDITION_VALUE");
	var prevselection = document.getElementById("PREVIOUS_BLOCK_CONDITION"); 
	if(selected == "NONE")
	{

		valueobj.readOnly = true;
		valueobj.disabled = true;
		oldvalueobj.value = valueobj.value;
		valueobj.value = "";
	}
	else
	{
		 if(prevselection.value != "NONE")	 
                 {	 
                     oldvalueobj.value = valueobj.value;    	 
                 }           
		valueobj.readOnly = false;
		valueobj.disabled = false;
		valueobj.value = oldvalueobj.value;
	}
		prevselection.value = selected;
}
//SwitchPortMapper

function setDDSPMShowResult(value)
{

var url="";
var resourceId=document.getElementById("RESOURCEID").value;

    if(value == "ALL_INTERFACES")
    {
        
	 url = "SPM_DD_View.cc?RESOURCEID="+resourceId;
	 AjaxAPI.sendRequest({METHOD:"POST",URL:url,TARGET:"_view_SPM_AssociatedInterface"});
    }
    else
    {
          
          url = "SPM_AssociatedInterface.cc?RESOURCEID="+resourceId;
	 AjaxAPI.sendRequest({METHOD:"POST",URL:url,TARGET:"_view_SPM_DD_View"});
    }

}

function setDGSPMShowResult(value)
{
    
    var resId = document.getElementById("SPM_DG_RESOURCEID").value;
    if(resId != null)
    {
	var url = "SPM_DG_ShowView.cc?SHOW_SELECTEDVALUE="+value+"&RESOURCEID="+resId;
	AjaxAPI.sendRequest({EFFECT:"Effect.Appear",METHOD:"POST",URL:url,TARGET:"_view_SPM_DG_ShowView"});
    }
}

function handleSPMResult(menuItemId,srcViewRefId,additionalParams,index)
{
    var selectobj = document.getElementById("SPM_SELECT");
    if(selectobj != null)
    {
	selectedvalue = selectobj.value;


    	additionalParams += "&SHOW_SELECTEDVALUE="+selectedvalue; 
    }
    TableDOMModel.showDetailsAction(menuItemId,srcViewRefId,additionalParams,index);
}