/* $Id: manualaddition.js,v 1.23 2009/10/21 06:21:18 gbalaji Exp $ */

/*------------------------------- Common Script functions - Starts ------------------------------*/



function showAddDeivce(menuItemId, srcViewRefId, additionalParams,index)
{
   var menuItemObj = getMenuItemObj(menuItemId);
   var url =  menuItemObj.getActionURL(srcViewRefId,additionalParams,index);

   if(_ISSTANDALONE)
   {
    var params = 'title='+I18N.getMsg("js.manualaddition.AddDevice");
   }
   else
   {
       var params = 'title=Import Device,position=relative,srcElement=showPopupDiv,left=300,top=50';
   }
   showURLInDialog(url,params);

}



function cleanOptionsInSelectBox(elementObj,addNONE)
{
//    var elementObj = eval(elementid);
    while(elementObj.length > 0)
    {
        for (var i=0;i<elementObj.length;i++)
        {
            elementObj.options[i] = null;
        }
    }
    
    if (addNONE)
    {
        elementObj.options[0] = new Option('NONE','NONE');
    }
}

/*------------------------------ Common Script functions - Ends ---------------------------------*/


// ********  Script for new inline AddDevice implementation ***************

function getDeviceTypeForVendor(form)
{   
    var xmlhttp = AjaxAPI.getXMLHttpRequest();



    var vendorName = form.VENDOR_NAME.value;
    var url = "jsp/manualaddition/FetchDeviceInfo.jsp?&ACTION=GET_DEVICETYPE&VENDOR_NAME="+vendorName;
    xmlhttp.open("GET",url,false);
    xmlhttp.send(null);

    var result = xmlhttp.responseText;
    result = trimAll(result);
    var deviceTypeField =  form.DEVICE_BEHAVIOUR;
    changeStatus(deviceTypeField,result);
}

function changeStatus(selectObj,result)
{
    var splitedResult = result.split(",");
    cleanOptionsInSelectBox(selectObj,true);
    for(var i=0;i<splitedResult.length;i++)
    {
        selectObj.options[i] = new Option(splitedResult[i], splitedResult[i]);
    }
}

function dnsResolved(form)
{
    var xmlhttp = AjaxAPI.getXMLHttpRequest();
    var ipaddress = form.IPADDRESS.value;
    if(!isNotEmpty(ipaddress))
    {
    return false;
    }
    var url = "jsp/manualaddition/FetchDeviceInfo.jsp?&ACTION=CHECK_DNSNAME&IPADDRESS="+ipaddress;
    xmlhttp.open("GET",url,false);
    xmlhttp.send(null);

    var result = xmlhttp.responseText;
    result = trimAll(result);
    if(result == "true")
    {
    return true;
    }
    else
    {
    return false;
    }
}

function showHideComponent(componentId, isShow)
{
        var showHideObjects = MM_findObj(componentId);
        if(isShow == true)
        {
                showHideObjects.className = '';
        }
        else
        {
                showHideObjects.className = 'hide';
        }

}


function pingDevice(pingip)
{
	if(is_demo)
	{
		return demoAlert();
	}
      if(!isNotEmpty(pingip))
      {
          alert("Enter Host Name or IP address");
          return;
      }
      viewname = 'NCMPingView.c?IPADDRESS=' + pingip;
      var params = 'title=Ping Status,closePrevious=false';
      showURLInDialog(viewname,params);
}


//////////////////////////////////////////////////////////

/* $Id: manualaddition.js,v 1.23 2009/10/21 06:21:18 gbalaji Exp $ */
var webp = "";
var popH = "";
var popW = "";
var popHeadr = "";
var loadMsg = "";

var browser = "";
var BrowserDetect = {
	init: function () {
		this.browser = this.searchString(this.dataBrowser) || "An unknown browser";
		this.version = this.searchVersion(navigator.userAgent)
			|| this.searchVersion(navigator.appVersion)
			|| "an unknown version";
		this.OS = this.searchString(this.dataOS) || "an unknown OS";
		//alert(this.browser);
		browser = this.browser;
	},
	searchString: function (data) {
		for (var i=0;i<data.length;i++)	{
			var dataString = data[i].string;
			var dataProp = data[i].prop;
			this.versionSearchString = data[i].versionSearch || data[i].identity;
			if (dataString) {
				if (dataString.indexOf(data[i].subString) != -1)
					return data[i].identity;
			}
			else if (dataProp)
				return data[i].identity;
		}
	},
	searchVersion: function (dataString) {
		var index = dataString.indexOf(this.versionSearchString);
		if (index == -1) return;
		return parseFloat(dataString.substring(index+this.versionSearchString.length+1));
	},
	dataBrowser: [
		{ 	string: navigator.userAgent,
			subString: "OmniWeb",
			versionSearch: "OmniWeb/",
			identity: "OmniWeb"
		},
		{
			string: navigator.vendor,
			subString: "Apple",
			identity: "Safari"
		},
		{
			prop: window.opera,
			identity: "Opera"
		},
		{
			string: navigator.vendor,
			subString: "iCab",
			identity: "iCab"
		},
		{
			string: navigator.vendor,
			subString: "KDE",
			identity: "Konqueror"
		},
		{
			string: navigator.userAgent,
			subString: "Firefox",
			identity: "Firefox"
		},
		{
			string: navigator.vendor,
			subString: "Camino",
			identity: "Camino"
		},
		{		// for newer Netscapes (6+)
			string: navigator.userAgent,
			subString: "Netscape",
			identity: "Netscape"
		},
		{
			string: navigator.userAgent,
			subString: "MSIE",
			identity: "Explorer",
			versionSearch: "MSIE"
		},
		{
			string: navigator.userAgent,
			subString: "Gecko",
			identity: "Mozilla",
			versionSearch: "rv"
		},
		{ 		// for older Netscapes (4-)
			string: navigator.userAgent,
			subString: "Mozilla",
			identity: "Netscape",
			versionSearch: "Mozilla"
		}
	],
	dataOS : [
		{
			string: navigator.platform,
			subString: "Win",
			identity: "Windows"
		},
		{
			string: navigator.platform,
			subString: "Mac",
			identity: "Mac"
		},
		{
			string: navigator.platform,
			subString: "Linux",
			identity: "Linux"
		}
	]

};
BrowserDetect.init();

function showPopUp(url,header,w,h,drag,popStatus,loadMsg, scrollOption)
{
document.getElementById('popmeup').style.display ='block';
var htmlcontent="<div id=\"popupOverlay\"></div><table width=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" id=\"adiv\"><tr><td colspan=\"2\" rowspan=\"2\" align=\"center\" valign=\"top\"><table width=\"100%\" height=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableOne\" id=\"tableOneStyle\"><tr><td align=\"left\" valign=\"middle\" class=\"tableHeader1\" id=\"tableHeaderStyle\" ><div id=\"floatTitle\">Map Views</div> <div id=\"floatButons\"><a href=\"javascript:shutPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapClose1Button.gif\" border=\"0\" align=\"absmiddle\" /></a></div><div id=\"popable\" style=\"float:right;\"><a href=\"javascript:pushPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapPopupButton.gif\" border=\"0\"/></a></div> <div style=\"clear:both;\"></div></td></tr><tr><td align=\"left\" valign=\"middle\" bgcolor=\"#FFFFFF\"><iframe class=\"ifr\" align=\"top\" frameborder=\"0\"  marginwidth=\"0px\" marginheight=\"0px\" width=\"100%\" height=\"100%\" name=\"ifr\" id=\"ifr\"></iframe><div id=\"floatContent\" style=\"height:100%; overflow-y: auto;\"></div></td></tr></table></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightTopFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"></td></tr><tr><td width=\"200\" align=\"left\" valign=\"top\" class=\"sideFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"  /></td></tr><tr><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"leftBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td><td width=\"100%\" height=\"11\" align=\"left\" valign=\"top\" class=\"botFill\"></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td></tr></table>";
var htmlcontentNoframe = "<div id=\"popupOverlay\"></div><table width=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" id=\"adiv\"><tr><td colspan=\"2\" rowspan=\"2\" align=\"center\" valign=\"top\"><table width=\"100%\" height=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableOne\" id=\"tableOneStyle\"><tr><td align=\"left\" valign=\"middle\" class=\"tableHeader1\" id=\"tableHeaderStyle\" ><div id=\"floatTitle\">Map Views</div> <div id=\"floatButons\"><a href=\"javascript:shutPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapClose1Button.gif\" border=\"0\" align=\"absmiddle\" /></a></div><div id=\"popable\" style=\"float:right;\"><a href=\"javascript:pushPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapPopupButton.gif\" border=\"0\"/></a></div> <div style=\"clear:both;\"></div></td></tr><tr><td align=\"left\" valign=\"middle\" bgcolor=\"#FFFFFF\"><iframe scrolling=\"no\" class=\"ifr\" align=\"top\" frameborder=\"0\"  marginwidth=\"0px\" marginheight=\"0px\" width=\"100%\" height=\"100%\" name=\"ifr\" id=\"ifr\" style=\"height:100%;width:100%;overflow-y:no;\"></iframe><div id=\"floatContent\" style=\"height:100%; overflow-y: auto;\"></div></td></tr></table></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightTopFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"></td></tr><tr><td width=\"200\" align=\"left\" valign=\"top\" class=\"sideFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"  /></td></tr><tr><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"leftBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td><td width=\"100%\" height=\"11\" align=\"left\" valign=\"top\" class=\"botFill\"></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td></tr></table>";
var htmlcontentNoframeFireFox = "<div id=\"popupOverlay\"></div><table width=\"100%\" height=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\" id=\"adiv\"><tr><td colspan=\"2\" rowspan=\"2\" align=\"center\" valign=\"top\"><table width=\"100%\" height=\"100%\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" class=\"tableOne\" id=\"tableOneStyle\"><tr><td align=\"left\" valign=\"middle\" class=\"tableHeader1\" id=\"tableHeaderStyle\" ><div id=\"floatTitle\">Map Views</div> <div id=\"floatButons\"><a href=\"javascript:shutPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapClose1Button.gif\" border=\"0\" align=\"absmiddle\" /></a></div><div id=\"popable\" style=\"float:right;\"><a href=\"javascript:pushPopUp()\"><img src=\"/ncm/themes/common/images/opmimages/mapPopupButton.gif\" border=\"0\"/></a></div> <div style=\"clear:both;\"></div></td></tr><tr><td align=\"left\" valign=\"middle\" bgcolor=\"#FFFFFF\"><iframe scrolling=\"no\" class=\"ifr\" align=\"top\" frameborder=\"0\"  marginwidth=\"0px\" marginheight=\"0px\" width=\"100%\" height=\"100%\" name=\"ifr\" id=\"ifr\" ></iframe><div id=\"floatContent\" style=\"height:100%; overflow-y: auto;\"></div></td></tr></table></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightTopFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"></td></tr><tr><td width=\"200\" align=\"left\" valign=\"top\" class=\"sideFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\"  /></td></tr><tr><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"leftBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td><td width=\"100%\" height=\"11\" align=\"left\" valign=\"top\" class=\"botFill\"></td><td width=\"10\" height=\"11\" align=\"left\" valign=\"top\" class=\"rightBotFill\"><img src=\"/ncm/themes/common/images/opmimages/spacer.gif\" width=\"10\" height=\"11\" /></td></tr></table>";
	if(scrollOption !='no' && scrollOption != undefined) {
        document.getElementById('popmeup').innerHTML= (htmlcontent);
    }
    else {
    if(browser == 'Explorer')
        document.getElementById('popmeup').innerHTML= (htmlcontentNoframe);
     else
        document.getElementById('popmeup').innerHTML= (htmlcontentNoframeFireFox);
    }
	document.getElementById('popupOverlay').style.height= document.body.scrollHeight;
	document.getElementById('popupOverlay').style.width= document.body.scrollWidth;
	document.getElementById('popupOverlay').style.height= document.body.offsetHeight+111+'px';
	document.getElementById('popupOverlay').style.width= document.body.offsetWidth+'px';
    document.getElementById('popupOverlay').style.top = '-111px';
	var posLeft = (document.body.offsetWidth-w)/2;
	document.getElementById('adiv').style.left= posLeft+'px';
	
	document.getElementById('adiv').style.width = w+'px';
	document.getElementById('adiv').style.height = h+'px';
	
	var shp = getScrollingPosition();
	document.getElementById('popupOverlay').style.display = 'block';
	document.getElementById('adiv').style.display = 'block';
	document.getElementById('floatTitle').innerHTML = header;
	document.getElementById('adiv').style.top = shp[1]+'px';
	if(drag) Drag.init(document.getElementById("adiv"));
	if(popStatus)
	{	
		document.getElementById('popable').style.display = 'block';
		webp = url;
		popH = h;
		popW = w;
		popHeader = header;
	}
	else document.getElementById('popable').style.display = 'none';
	document.getElementById('ifr').src = url;
	document.getElementById('ifr').width = (w)+'px';
	document.getElementById('ifr').height = (h)+'px';
}	
function ifrInit(){
	 document.getElementById('popmeup').style.height = '1px';
}
function shutPopUp()
{
	document.getElementById('ifr').src = '/webclient/devices/html/blank.html';
	document.getElementById('popupOverlay').style.display = 'none';
	document.getElementById('adiv').style.display = 'none';
	document.getElementById('popmeup').style.display = 'none';
}

function pushPopUp()
{
	document.getElementById('popupOverlay').style.display = 'none';
	document.getElementById('adiv').style.display = 'none';
	popWindow = window.open(webp,popHeader,"height=h,width=w");
	popWindow.focus( );
}

function getScrollingPosition()
{
    var position = [0, 0];
    if (typeof window.pageYOffset != 'undefined') position = [window.pageXOffset,window.pageYOffset];

    else if (typeof document.documentElement.scrollTop!= 'undefined' && document.documentElement.scrollTop > 0) 
	    position = [document.documentElement.scrollLeft,document.documentElement.scrollTop];
	
    else if (typeof document.body.scrollTop != 'undefined')	position = [document.body.scrollLeft,document.body.scrollTop];

    return position;

}
function clearCookies()
{
	if(getCookie("signInAutomatically") == 'true')
	{
		deleteCookie("signInAutomatically");
		deleteCookie("userNameForAutomaticSignin");
		deleteCookie("passwordForAutomaticSignin");
		deleteCookie("NCMTICKET");
	}
}

function simpleSearch()
{

    var sterm = trimAll(document.SearchForm.searchTerm.value);
    if(sterm == '' ||  (sterm.indexOf('...Device Search...')>0) )
    {
	    alert("Please enter a search term");
	    document.SearchForm.searchTerm.value = "";
	    document.SearchForm.searchTerm.focus();
	    return false;
    }
    document.SearchForm.searchTerm.value = sterm;
    document.SearchForm.submit();
}

function changeHeaderColor(abt){
	var shpN = getScrollingPosition();
	if(abt=='about'){
		document.getElementById('tableHeaderStyle').className="tableHeaderBlack";
			document.getElementById('floatTitle').style.color="#ffffff";
		document.getElementById('adiv').style.top = shpN[1]+(63)+'px';
		document.getElementById('tableOneStyle').className="tableOneBlack";

	}else{
		document.getElementById('tableHeaderStyle').className="tableHeader";
		document.getElementById('floatTitle').style.color="#003366";
		document.getElementById('adiv').style.top = shpN[1]+'px';
		document.getElementById('tableOneStyle').className="tableOne";
	}

}
function copyContents1(objContent,toObj)
{
    clearSelectObj(toObj);
    var count = 0;
    for(var value in objContent)
    {
        var displayname = objContent[value];
        if(displayname != null)
        {
            toObj.options[count++] = new Option(value,objContent[value],false,false);
        }
    }
}
function doFilter1(contents,searchStr) 
{
    if(searchStr.length == 0)
        return contents;
    var tempContent = new Object();
    var text = '';

    for(var value in contents)
    {
        text = contents[value];
        if(text != null)
        {
            text = text.substring(0,searchStr.length);
            text = text.toLowerCase();
	    searchStr = searchStr.toLowerCase();	
            if (searchStr == text )
            {
                tempContent[value] = contents[value];
            }
        }
    }
    return tempContent;
}

function searchData1(contents,showObj,searchStr)
{
    var currentContent = doFilter1(contents,searchStr);
    copyContents1(currentContent,showObj);
}

var hideDiv = "";

function hideDropDiv(e){
	document.getElementById(hideDiv).style.display = "none";
}

function delayhideDropDiv(msec,whereto){
hideDiv = whereto;
clearhideDropDiv();
delayDropDiv=setTimeout("hideDropDiv()",msec);
}

function clearhideDropDiv(){
if (typeof delayDropDiv!="undefined")
    clearTimeout(delayDropDiv);
}

function swapJumpDiv()
{
  var hideJump = "";
  hideJump=document.getElementById('jumptoContent').style;
  if (hideJump.display == 'none' || hideJump.display == '')
  {
   clearhideDropDiv();
      eval("hideJump.display = 'block'");
        }
  else
  {
       delayhideDropDiv(0,'jumptoContent');
  }
}

function showImportDeviceOpm(menuItemId, srcViewRefId, additionalParams,index)
 	 {
 	    var menuItemObj = getMenuItemObj(menuItemId);
 	    var url =  menuItemObj.getActionURL(srcViewRefId,additionalParams,index);
 	    var params = 'title=Import SNMP Devices,position=relative,width=700,left=250,top=50';
 	    showURLInDialog(url,params);
 	 
 	 }

